#include "general.h"
#include "Base/File.h"

//ZwOpenFile(...);
/*
 * ShareAccess:FILE_SHARE_READFILE_SHARE_WRITE,FILE_SHARE_DELETE
 */
EXERESULT FileR0Open(__out PHANDLE pHandle,WCHAR * pntFileName,ULONG ShareAccess){
	EXERESULT rt = SS_SUCCESS;
	NTSTATUS ntStatus;
	OBJECT_ATTRIBUTES ObjAttr;
	WCHAR buf[FILE_MAX_PATH_LENGHT];
	UNICODE_STRING keFileName;
	IO_STATUS_BLOCK IoStatusBlock;

	keFileName.Length = (wcslen(L"\\??\\")+wcslen(pntFileName))*sizeof(WCHAR);		//ȲNULL
	keFileName.Buffer = buf;		//ڱͷ
	KdPrint(("HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH  %ws   %X\n",pntFileName,wcslen(pntFileName)));
	if(keFileName.Buffer == NULL)
		return  SS_ALLOC_MEM_ERR;

	wcscpy(keFileName.Buffer,L"\\??\\");
	wcscat(keFileName.Buffer,pntFileName);
	//KdPrint(("%d %d %d\n",wcslen(L"\\??\\"),wcslen(pntFileName),wcslen(keFileName.Buffer)));
	KdPrint(("FileR0Create--FilePath: %ws\n",keFileName.Buffer));
	InitializeObjectAttributes(
		&ObjAttr,
		&keFileName,
		OBJ_CASE_INSENSITIVE|
		OBJ_KERNEL_HANDLE,	//ִСд
		NULL,
		NULL
		);
	if(pHandle == NULL)
		return SS_CREATE_FILE_ERR;
	if(KeGetCurrentIrql()>PASSIVE_LEVEL )
	{
		KdPrint(("IRQ ERR in FileR0Open"));
		return SS_IRQ_LEVEL_ERR;
	}
	//__asm int 3;
	KdPrint(("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n"));
	ntStatus = IoCreateFile(							//FileR0Closeйر
		pHandle,						//
		GENERIC_READ | GENERIC_WRITE,
		&ObjAttr,
		&IoStatusBlock,
		NULL,
		FILE_ATTRIBUTE_NORMAL,
		ShareAccess,					//
		FILE_OPEN_IF,
		FILE_NON_DIRECTORY_FILE |
		FILE_RANDOM_ACCESS |
		FILE_SYNCHRONOUS_IO_NONALERT,	//вͬ޾
		NULL,
		0,
		CreateFileTypeNone,
		NULL,
		IO_NO_PARAMETER_CHECKING
		);
	if(!NT_SUCCESS(ntStatus))
	{
		KdPrint(("ļڴʱˣΪ%08X\n",ntStatus));
		rt = SS_CREATE_FILE_ERR;
	}
	return rt;
}
EXERESULT FileR0Read(HANDLE FileHandle,PVOID pBuf,PLARGE_INTEGER pOffset,ULONG Length){
	EXERESULT rt = SS_SUCCESS;
	NTSTATUS ntStatus;
	IO_STATUS_BLOCK IoStatusBlock;
	FILE_STANDARD_INFORMATION Fsi;
	/*
	ntStatus = ZwQueryInformationFile(FileHandle,
		&IoStatusBlock,
		&Fsi,
		sizeof(FILE_STANDARD_INFORMATION),
		FileStandardInformation);
	*/
	if(KeGetCurrentIrql() != PASSIVE_LEVEL){
		KdPrint(("IRQ ERR in FileR0Read"));
		return SS_IRQ_LEVEL_ERR;
	}
	ntStatus = ZwReadFile(FileHandle,
		NULL,
		NULL,
		NULL,
		&IoStatusBlock,
		pBuf,
		Length,							//(LONG)Fsi.EndOfFile.QuadPart ȡļ
		pOffset,						//ΪNULLǰļָ뼴ƫƣ pOffset->HighPart = -1  &&  pOffset->LowPart = FILE_USE_FILE_POINTER_POSITION
		NULL);
	if(!NT_SUCCESS(ntStatus))
	{
		FileR0Close(FileHandle);
		rt = SS_READ_FILE_ERR;
	}
	return rt;
}

EXERESULT FileR0Write(HANDLE FileHandle,PVOID pBuf,PLARGE_INTEGER pOffset,ULONG Length){
	EXERESULT rt = SS_SUCCESS;
	NTSTATUS ntStatus;
	IO_STATUS_BLOCK IoStatusBlock;
	FILE_STANDARD_INFORMATION Fsi;
	/*
	ntStatus = ZwQueryInformationFile(FileHandle,
		&IoStatusBlock,
		&Fsi,
		sizeof(FILE_STANDARD_INFORMATION),
		FileStandardInformation);
	*/
	if(KeGetCurrentIrql() != PASSIVE_LEVEL){
		KdPrint(("IRQ ERR in FileR0Write"));
		return SS_IRQ_LEVEL_ERR;
	}
	ntStatus = ZwWriteFile(FileHandle,
		NULL,
		NULL,
		NULL,
		&IoStatusBlock,
		pBuf,
		Length,							//(LONG)Fsi.EndOfFile.QuadPart ȡļ
		pOffset,						//ΪNULLǰļָ뼴ƫƣ pOffset->HighPart = -1  &&  pOffset->LowPart = FILE_USE_FILE_POINTER_POSITION
		NULL);
	if(!NT_SUCCESS(ntStatus))
	{
		FileR0Close(FileHandle);
		rt = SS_READ_FILE_ERR;
	}
	return rt;
}

EXERESULT FileR0Close(HANDLE FileHandle){
	EXERESULT rt = SS_SUCCESS;
	if(FileHandle!=NULL)
		ZwClose(FileHandle);
	return rt;
}