#include "general.h"
#include "VMM/Device/SDMR0.h"
#include "VMM/CVCR0.h"

EXERESULT SDMR0Create(tpSDM pSDM,PVOID pCVC){
	EXERESULT rt = SS_SUCCESS;
	KdPrint(("SDMR0Create\n"));

	//IDE
	//

	rt = DiskLink(&pSDM->Disk,pCVC);
	if(rt != SS_SUCCESS)
		return rt;									//Disk is linked successfully!

	//SCSI

	//Floppy
	rt = FloppyLink(&pSDM->Floppy);
	if(rt != SS_SUCCESS)
	{
		//Unlink Disk
		DiskUnLink(&pSDM->Disk);
		return rt;									//Floppy is linked successfully!
	}


	//USB()

	//LPT()

	//COM()

	return rt;
}
EXERESULT SDMR0Release(tpSDM pSDM){
	EXERESULT rt = SS_SUCCESS;
	KdPrint(("SDMR0Release\n"));
	rt = GETFIRSTERROR(rt,DiskUnLink(&pSDM->Disk));
	rt = GETFIRSTERROR(rt,FloppyUnLink(&pSDM->Floppy));
	return rt;
}